
Ruby - Bug #21012

Compiling `a['a','b'],=1` with parse.y fails

01/07/2025 06:43 PM - tompng (tomoya ishida)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.5.0dev (2025-01-06T01:50:53Z

master c8e3d745fa) [x86_64-linux]

Backport: 3.1: REQUIRED, 3.2: DONE, 3.3:

DONE, 3.4: DONE

Description

Compiling this code with parse.y fails with segmentation fault.

a['a','b'],=1

 Compiling a['a',x],=1 generates instruction sequence that wrong contains opt_aset_with.

$ ruby --parser=parse.y --dump=insn -e "a['a',999],=1"

== disasm: #<ISeq:<main>@-e:1 (1,0)-(1,13)>

0000 putself                                                          (   1)[Li]

0001 opt_send_without_block                 <calldata!mid:a, argc:0, FCALL|VCALL|ARGS_SIMPLE>

0003 putobject_INT2FIX_1_

0004 dup

0005 expandarray                            1, 0

0008 topn                                   1001

....

2006 topn                                   1001

2008 topn                                   1000

2010 opt_aset_with                          "a", <calldata!mid:[]=, argc:2, ARGS_SIMPLE>

2013 setn                                   1000

2015 pop

....

3014 pop

3015 leave

Associated revisions

Revision e0d600ec190c64aff76cfcbd6009cffb927da166 - 01/08/2025 04:49 PM - jeremyevans (Jeremy Evans)

Avoid opt_aset_with optimization inside multiple assignment

Previously, since the opt_aset_with optimization was introduced,

use of the opt_aset_with optimization inside multiple assignment

would result in a segfault or incorrect instructions.

Fixes [Bug #21012]

Co-authored-by: Nobuyoshi Nakada nobu.nakada@gmail.com

Revision e0d600ec190c64aff76cfcbd6009cffb927da166 - 01/08/2025 04:49 PM - jeremyevans (Jeremy Evans)

Avoid opt_aset_with optimization inside multiple assignment

Previously, since the opt_aset_with optimization was introduced,

use of the opt_aset_with optimization inside multiple assignment

would result in a segfault or incorrect instructions.

Fixes [Bug #21012]

Co-authored-by: Nobuyoshi Nakada nobu.nakada@gmail.com

Revision e0d600ec - 01/08/2025 04:49 PM - jeremyevans (Jeremy Evans)

Avoid opt_aset_with optimization inside multiple assignment

Previously, since the opt_aset_with optimization was introduced,
use of the opt_aset_with optimization inside multiple assignment

would result in a segfault or incorrect instructions.

Fixes [Bug #21012]

Co-authored-by: Nobuyoshi Nakada nobu.nakada@gmail.com

Revision 3a986b47cba80bdc081638d5f759a26c1beb8fad - 01/15/2025 01:56 AM - k0kubun (Takashi Kokubun)

merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

    Avoid opt_aset_with optimization inside multiple assignment

    Previously, since the opt_aset_with optimization was introduced,

    use of the opt_aset_with optimization inside multiple assignment

    would result in a segfault or incorrect instructions.

    Fixes [Bug #21012]

    Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

Revision 3a986b47cba80bdc081638d5f759a26c1beb8fad - 01/15/2025 01:56 AM - k0kubun (Takashi Kokubun)

merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

    Avoid opt_aset_with optimization inside multiple assignment

    Previously, since the opt_aset_with optimization was introduced,

    use of the opt_aset_with optimization inside multiple assignment

    would result in a segfault or incorrect instructions.

    Fixes [Bug #21012]

    Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

Revision 3a986b47 - 01/15/2025 01:56 AM - k0kubun (Takashi Kokubun)

merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

    Avoid opt_aset_with optimization inside multiple assignment

    Previously, since the opt_aset_with optimization was introduced,

    use of the opt_aset_with optimization inside multiple assignment

    would result in a segfault or incorrect instructions.

    Fixes [Bug #21012]

    Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

Revision f9adaab928dff8dd7ecd4c560c288300a3c74880 - 01/25/2025 05:37 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

    Avoid opt_aset_with optimization inside multiple assignment

    Previously, since the opt_aset_with optimization was introduced,

    use of the opt_aset_with optimization inside multiple assignment

    would result in a segfault or incorrect instructions.

    Fixes [Bug #21012]

    Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

Revision f9adaab928dff8dd7ecd4c560c288300a3c74880 - 01/25/2025 05:37 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

    Avoid opt_aset_with optimization inside multiple assignment

    Previously, since the opt_aset_with optimization was introduced,

    use of the opt_aset_with optimization inside multiple assignment

    would result in a segfault or incorrect instructions.

    Fixes [Bug #21012]

06/29/2025 2/4

mailto:nobu.nakada@gmail.com


    Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

Revision f9adaab9 - 01/25/2025 05:37 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

    Avoid opt_aset_with optimization inside multiple assignment

    Previously, since the opt_aset_with optimization was introduced,

    use of the opt_aset_with optimization inside multiple assignment

    would result in a segfault or incorrect instructions.

    Fixes [Bug #21012]

    Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

Revision 3fdf7279a0b1ac35fdf233464a93b3d268133d5a - 02/14/2025 05:08 AM - k0kubun (Takashi Kokubun)

merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

    Avoid opt_aset_with optimization inside multiple assignment

    Previously, since the opt_aset_with optimization was introduced,

    use of the opt_aset_with optimization inside multiple assignment

    would result in a segfault or incorrect instructions.

    Fixes [Bug #21012]

    Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

Revision 3fdf7279a0b1ac35fdf233464a93b3d268133d5a - 02/14/2025 05:08 AM - k0kubun (Takashi Kokubun)

merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

    Avoid opt_aset_with optimization inside multiple assignment

    Previously, since the opt_aset_with optimization was introduced,

    use of the opt_aset_with optimization inside multiple assignment

    would result in a segfault or incorrect instructions.

    Fixes [Bug #21012]

    Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

Revision 3fdf7279 - 02/14/2025 05:08 AM - k0kubun (Takashi Kokubun)

merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

    Avoid opt_aset_with optimization inside multiple assignment

    Previously, since the opt_aset_with optimization was introduced,

    use of the opt_aset_with optimization inside multiple assignment

    would result in a segfault or incorrect instructions.

    Fixes [Bug #21012]

    Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

History

#1 - 01/07/2025 08:15 PM - jeremyevans0 (Jeremy Evans)

- Backport changed from 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3: UNKNOWN, 3.4: UNKNOWN to 3.1: REQUIRED, 3.2: REQUIRED, 3.3: REQUIRED,

3.4: REQUIRED

From testing some historical versions on my system:

For: a['a','b'],=1

Ruby 1.9-2.5: No segfault, looks to be correct instructions

Ruby 2.6-3.1: Segfault

Ruby 3.2: No segfault, but incorrect instructions

Ruby 3.3-3.4: Segfault

For: a['a',10],=1:
Ruby 1.9-2.5: No segfault, looks to be correct instructions

Ruby 2.6-3.1: Segfault

Ruby 3.2-3.4: No segfault, but incorrect instructions

#2 - 01/08/2025 01:38 AM - jeremyevans0 (Jeremy Evans)

I've submitted a PR that should fix this: https://github.com/ruby/ruby/pull/12528

#3 - 01/08/2025 05:24 PM - jeremyevans (Jeremy Evans)

- Status changed from Open to Closed

Applied in changeset git|e0d600ec190c64aff76cfcbd6009cffb927da166.

Avoid opt_aset_with optimization inside multiple assignment

Previously, since the opt_aset_with optimization was introduced,

use of the opt_aset_with optimization inside multiple assignment

would result in a segfault or incorrect instructions.

Fixes [Bug #21012]

Co-authored-by: Nobuyoshi Nakada nobu.nakada@gmail.com

#4 - 01/15/2025 01:56 AM - k0kubun (Takashi Kokubun)

- Backport changed from 3.1: REQUIRED, 3.2: REQUIRED, 3.3: REQUIRED, 3.4: REQUIRED to 3.1: REQUIRED, 3.2: REQUIRED, 3.3: DONE, 3.4:

REQUIRED

ruby_3_3 3a986b47cba80bdc081638d5f759a26c1beb8fad merged revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166.

#5 - 01/25/2025 06:33 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.1: REQUIRED, 3.2: REQUIRED, 3.3: DONE, 3.4: REQUIRED to 3.1: REQUIRED, 3.2: DONE, 3.3: DONE, 3.4: REQUIRED

ruby_3_2 f9adaab928dff8dd7ecd4c560c288300a3c74880 merged revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166.

#6 - 02/14/2025 05:08 AM - k0kubun (Takashi Kokubun)

- Backport changed from 3.1: REQUIRED, 3.2: DONE, 3.3: DONE, 3.4: REQUIRED to 3.1: REQUIRED, 3.2: DONE, 3.3: DONE, 3.4: DONE

ruby_3_4 3fdf7279a0b1ac35fdf233464a93b3d268133d5a merged revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166.

Powered by TCPDF (www.tcpdf.org)

06/29/2025 4/4

https://github.com/ruby/ruby/pull/12528
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/e0d600ec190c64aff76cfcbd6009cffb927da166
https://redmine.ruby-lang.org/issues/21012
mailto:nobu.nakada@gmail.com
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/3a986b47cba80bdc081638d5f759a26c1beb8fad
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/e0d600ec190c64aff76cfcbd6009cffb927da166
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/f9adaab928dff8dd7ecd4c560c288300a3c74880
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/e0d600ec190c64aff76cfcbd6009cffb927da166
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/3fdf7279a0b1ac35fdf233464a93b3d268133d5a
https://redmine.ruby-lang.org/projects/ruby-master/repository/git/revisions/e0d600ec190c64aff76cfcbd6009cffb927da166
http://www.tcpdf.org

